<template>
  <div class="wrap">
    <div class="container" v-if="authChecked">
      <div class="content">
        <button :disabled="loading || isAuth" @click="login">
          {{ !isAuth ? "connect" : "connected" }}
        </button>

        <template v-if="isAuth">
          <div v-if="isInited" class="header">
            <span class="title">{{ isStakeMode ? "stake" : "unstake" }}</span
            ><span class="price"
              >{{ balanceData.mainBalance }} nICE = ${{
                balanceData.mainPrice
              }}</span
            >
          </div>

          <div class="balance">
            <div>
              nICE:
              <template v-if="isInited">{{ balanceData.mainBalance }}</template>
            </div>
            <div>
              ICE:
              <template v-if="isInited">{{
                balanceData.stakeBalance
              }}</template>
            </div>
          </div>

          <form>
            <div class="lock-time" v-if="!isStakeMode && isLocked">
              Unlock in: {{ lockTimeString }}
            </div>
            <div
              class="form-inputs"
              :class="{ 'form-inputs-unstake': !isStakeMode }"
            >
              <div class="field">
                <label for="ice">ICE</label>
                <input
                  :disabled="loading || !isInited"
                  v-model="ice"
                  id="ice"
                  type="number"
                  :readonly="!isStakeMode"
                  :placeholder="isStakeMode ? '0.00' : ''"
                  min="0"
                  :max="balanceData.stakeBalance"
                />
                <div
                  class="error"
                  v-if="isStakeMode && ice !== null && !isValid"
                >
                  Valid value is in the range from 0 to
                  {{ balanceData.stakeBalance }}
                </div>
              </div>
              <button
                :disabled="loading || !isInited"
                @click.prevent="isStakeMode = !isStakeMode"
                type="button"
                class="change-mode-btn"
              >
                ⟳
              </button>
              <div class="field">
                <label for="nice">nICE</label>
                <input
                  :disabled="loading || !isInited"
                  v-model="nice"
                  id="nice"
                  type="number"
                  :readonly="isStakeMode"
                  :placeholder="!isStakeMode ? '0.00' : ''"
                  min="0"
                  :max="balanceData.mainBalance"
                />
                <div
                  class="error"
                  v-if="!isStakeMode && nice !== null && !isValid"
                >
                  Valid value is in the range from 0 to
                  {{ balanceData.mainBalance }}
                </div>
              </div>
            </div>

            <button
              v-if="isInited"
              :disabled="loading || !isValid || (!this.isStakeMode && isLocked)"
              @click.prevent="
                isAllowance ? (isStakeMode ? stake() : unstake()) : approve()
              "
              type="submit"
              class="send-btn"
            >
              {{
                isAllowance ? (isStakeMode ? "stake" : "unstake") : "approve"
              }}
            </button>
          </form></template
        >
      </div>
    </div>
  </div>
</template>

<script>
import { ethers, FixedNumber } from "ethers";
import moment from "moment";

import "./style.css";

import { getAbi, getTokenPrice } from "./api";
import { roundEth } from "./utils";

const stakeToken = "0xf16e81dce15b08f326220742020379b855b87df9";
const mainToken = "0xfF3Ac80c1caA08Cbd43a7e90d20c398d54C7342f";

const iceTokenIds = "ice-token";

export default {
  name: "App",
  data: () => ({
    loading: false,
    authChecked: false,
    isInited: false,
    account: null,
    mainContract: null,
    stakeContract: null,
    mainPrice: 0,
    decimals: 18,
    isStakeMode: true,
    ice: null,
    nice: null,
    stakeBalance: 0,
    mainBalance: 0,
    isAllowance: false,
    lockedTime: null,
    lockTimeout: null,
    lockTimeString: "",
    isLocked: false,
  }),
  computed: {
    isValid() {
      return (
        (this.isStakeMode &&
          this.ice !== null &&
          Number(this.ice) >= 0 &&
          Number(this.ice) <= Number(this.balanceData.stakeBalance)) ||
        (!this.isStakeMode &&
          this.nice !== null &&
          Number(this.nice) >= 0 &&
          Number(this.nice) <= Number(this.balanceData.mainBalance))
      );
    },
    isAuth() {
      return !!this.account;
    },
    balanceData() {
      return {
        mainBalance: roundEth(this.mainBalance),
        stakeBalance: roundEth(this.stakeBalance),
        mainPrice: roundEth(
          FixedNumber.from(this.mainBalance)
            .mulUnsafe(FixedNumber.from(String(this.mainPrice)))
            .toString(),
          1e2
        ),
      };
    },
  },
  methods: {
    accountsChangedHandler(accounts) {
      this.account = accounts[0] || null;
    },

    disconnect() {
      window.ethereum?.removeListener(
        "accountsChanged",
        this.accountsChangedHandler
      );
    },

    connect() {
      this.disconnect();
      window.ethereum?.on("accountsChanged", this.accountsChangedHandler);
    },

    async login() {
      try {
        this.loading = true;
        if (window.ethereum?.isMetaMask) {
          await window.ethereum?.request({ method: "eth_requestAccounts" });
          this.connect();
        }
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    },
    async check() {
      try {
        if (window.ethereum?.isMetaMask) {
          const accounts = await window.ethereum?.request({
            method: "eth_accounts",
          });
          if (accounts[0]) {
            this.account = accounts[0];
          }
          this.connect();
        }
      } catch (e) {
        console.error(e);
      } finally {
        this.authChecked = true;
      }
    },
    async updateAllowance() {
      this.isAllowance =
        (
          await this.stakeContract.allowance(this.account, mainToken)
        ).toString() !== "0";
    },
    async checkTime() {
      this.lockedTime = (
        await this.mainContract.users(this.account)
      ).lockedUntil.toString();

      this.isLocked =
        this.lockedTime !== null
          ? Number(this.lockedTime) - moment().unix() > 0
          : false;

      clearTimeout(this.lockTimeout);
      if (this.isLocked) {
        const prep = (time) => {
          return String(time).padStart(2, 0);
        };

        const getTimeString = (duration) =>
          `${prep(duration.hours())}:${prep(duration.minutes())}:${prep(
            duration.seconds()
          )}`;

        const startDuration = this.getLockDuration();
        this.lockTimeString = getTimeString(startDuration);

        this.lockTimeout = setTimeout(() => {
          setInterval(() => {
            this.lockTimeString = getTimeString(this.getLockDuration());
          }, 1000);
        }, startDuration.milliseconds());
      }
    },
    async updateBalance() {
      const stakeBalance = await this.stakeContract.balanceOf(this.account);
      const mainBalance = await this.mainContract.balanceOf(this.account);

      this.stakeBalance = ethers.utils.formatUnits(stakeBalance, this.decimals);

      this.mainBalance = ethers.utils.formatUnits(mainBalance, this.decimals);
    },

    async calcPrice() {
      this.mainPrice = await getTokenPrice(iceTokenIds);
    },

    async initProv() {
      try {
        this.loading = true;
        const provider = new ethers.providers.Web3Provider(window.ethereum);

        const signer = await provider.getSigner();

        const mainAbi = await getAbi(mainToken);

        this.mainContract = new ethers.Contract(mainToken, mainAbi, signer);
        const stakeAbi = await getAbi(stakeToken);

        this.stakeContract = new ethers.Contract(stakeToken, stakeAbi, signer);

        this.decimals = await this.stakeContract.decimals();

        await this.updateBalance();
        await this.updateAllowance();
        await this.checkTime();
        await this.calcPrice();

        this.isInited = true;
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    },
    async approve() {
      try {
        await this.stakeContract.approve(
          mainToken,
          "0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff"
        );
        await this.updateAllowance();
      } catch (e) {
        console.error(e);
      }
    },
    async stake() {
      try {
        this.loading = true;
        const value = ethers.utils.parseUnits(String(this.ice), this.decimals);
        await this.mainContract.mint(value);
        this.clear();
      } finally {
        this.loading = false;
      }
    },
    async unstake() {
      try {
        this.loading = true;
        const value = ethers.utils.parseUnits(String(this.nice), this.decimals);
        await this.mainContract.burn(this.account, value);
        this.clear();
      } finally {
        this.loading = false;
      }
    },
    clear() {
      this.ice = null;
      this.nice = null;
    },
    getLockDuration() {
      return moment.duration(moment.unix(this.lockedTime).diff(moment()));
    },
  },
  watch: {
    isLocked(value) {
      if (!value) this.checkTime();
    },
    isAuth: {
      immediate: true,
      handler(value) {
        if (value) this.initProv();
      },
    },
    isStakeMode() {
      this.clear();
    },
  },
  mounted() {
    this.check();
  },
};
</script>

<style></style>
